#!/usr/bin/env python
#
# Copyright (c) 2016-2022, Virtuozzo International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#

import json
import os
import re
import time
from infra_cep_helper import CEPCollecting, MAX_SCRIPT_RETRIES


class VEs(CEPCollecting):
    def fill_results(self):
        root_hdd_file = []
        root_hdd_dir = []
        cmd = "/usr/sbin/vzlist --json -a"
        out = self.execute_shell(cmd)
        ves = json.loads(out)
        for ve in ves:
            disk_path = os.path.join(ve["private"], "root.hdd")
            if os.path.isdir(disk_path):
                if os.path.exists(disk_path + "/root.hds"):
                    cmd = "/usr/bin/file {}".format(disk_path + "/root.hds") 
                    out = self.execute_shell(cmd)
                    root_hdd_dir.append(out)
            if os.path.isfile(disk_path):
                cmd = "/usr/bin/file {}".format(disk_path)
                out = self.execue_shell(cmd)
                root_hdd_file.append(out)
               
        self.result["template_cache"] = next(os.walk("/vz/template/cache/"), (None, None, []))[2]
        self.result["root_hdd_file"] = root_hdd_file
        self.result["root_hdd_dir"] = root_hdd_dir


def main():
    o = VEs()
    o.run()


if __name__ == "__main__":
    main()
