#!/usr/bin/env python
#
# Copyright (c) 2016-2018, Virtuozzo International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#
from infra_cep_helper import CEPCollecting
import subprocess
import json
import os

class DockerPs(CEPCollecting):

    def docker_status(self):
        # get docker ps json's
        # curl --unix-socket /var/run/docker.sock http://localhost/containers/json > /tmp/te.json
        socket_path = '/var/run/docker.sock'
        addr = 'http://localhost/containers/json'
        docker_status = []
        if os.path.exists(socket_path):
           try:
              docker_ps = subprocess.check_output(['curl', '--silent', '--unix-socket', socket_path, addr])
              docker_status = json.loads(docker_ps)
           except Exception:
              return docker_status
        return docker_status


    def fill_results(self):
        self.result["docker_ps"] = self.docker_status()


def main():
    o = DockerPs()
    o.run()


if __name__ == "__main__":
    main()
