#!/usr/bin/env python
#
# Copyright (c) 2016-2018, Virtuozzo International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#

import re
from infra_cep_helper import CEPCollecting


class License(CEPCollecting):
    def fill_results(self):
        out = self.execute_shell("/usr/sbin/vzlicview --class VZSRV")
        for l in out.splitlines():
            if '=' not in l:
                continue
            (k, v) = l.strip().split('=', 1)
            self.result[k] = v.strip('"')

        if "owner_name" in self.result:
            try:
                regex = re.compile('[^(]+\(([^)]+)\)')
                a = re.findall(regex, self.result["owner_name"])
                self.result["owner_company"] = a[0]
            except:
                pass
        if "owner_id" in self.result:
            try:
                regex = re.compile('([^.]+)\..*')
                a = re.findall(regex, self.result["owner_id"])
                self.result["client_id"] = a[0]
            except:
                pass


def main():
    o = License()
    o.run()


if __name__ == "__main__":
    main()
