#!/usr/bin/env python
#
# Copyright (c) 2016-2018, Virtuozzo International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#

import re
from infra_cep_helper import CEPCollecting


class Memory(CEPCollecting):
    def meminfo(self):
        value = ""
        key = ""
        memlist = {}
        with open("/proc/meminfo", "r") as f:
            for line in f:
                if ":" in line:
                    line_array = line.strip().split(":")
                    key = line_array[0].strip()
                    value = ":".join(line_array[1:]).lstrip()
                    if key in memlist:
                        # append to existing key
                        memlist[key].append(value)
                    else:
                        memlist[key] = [value]
        return memlist

    def fill_results(self):
        self.result["/proc/meminfo"] = self.meminfo()


def main():
    o = Memory()
    o.run()


if __name__ == "__main__":
    main()
