#!/usr/bin/env python
#
# Copyright (c) 2016-2018, Virtuozzo International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#

from infra_cep_helper import CEPCollecting


class Partitions(CEPCollecting):
    def fill_results(self):
        l = list()
        clust_idx = 0
        with open("/proc/mounts", "r") as file:
            for line in file:
                (dev, mountpoint, fs, options, unused) = line.split(" ", 4)
                if dev.startswith("vstorage:"):
                    dev = "vstorage://clust" + str(clust_idx)
                    clust_idx += 1
                l.insert(0, {"XmlLabel": "Mount",
                             "Device": dev,
                             "Mountpoint": mountpoint,
                             "Filesystem": fs,
                             "Options": options.strip()})

        self.result["Partitions"] = l


def main():
    o = Partitions()
    o.run()


if __name__ == "__main__":
    main()
