from infra_cep_helper import CEPCollecting
import subprocess
import os

ploop_dict = {}


class ploop(CEPCollecting):
    def get_ploops(self):
        ploop_list = []
        for root, dirs, files in os.walk("/sys/block/"):
            for dir in dirs:
                if dir.startswith("ploop"):
                    ploop_list.append(os.path.join(root, dir))
        return ploop_list

    def ploop_info(self, ploop):
        pdelta = ploop + '/pdelta/0/io'
        ptune = ploop + '/ptune/discard_granularity'
        # just ignore if not exist
        try:
            with open(pdelta) as f:
                pdelta_value = f.read().split()
                if ploop not in ploop_dict:
                    ploop_dict[ploop] = [pdelta_value[0]]
                else:
                    ploop_dict[ploop].append(pdelta_value[0])
        # just ignore if can't read
        except IOError:
            pass

        try:
            with open(ptune) as f:
                ptune_value = f.read().split()
                if ploop not in ploop_dict:
                    ploop_dict[ploop] = [ptune_value[0]]
                else:
                    ploop_dict[ploop].append(ptune_value[0])
        # just ignore if can't read
        except IOError:
            pass


    def dm_ploops(self):
        dm_ploops = {"ploop": [], "qcow2": []}
        try:
           dmsetup = subprocess.check_output(['dmsetup', 'table']).decode()
           for line in dmsetup.splitlines():
               id = line.split(":")[0]
               if "qcow2" in line and id not in dm_ploops["qcow2"]:
                   dm_ploops["qcow2"].append(id)
               if "ploop" in line and not "qcow2" in line and id not in dm_ploops["ploop"]:
                   dm_ploops["ploop"].append(id)
        except Exception:
            pass
        return dm_ploops


    def ioctl_ftrim(self):
        ftrim_value = ""
        sys_ftrim = "/sys/module/ve/parameters/allow_ioctl_fitrim"
        ftrim_value = ''
        try:
            with open(sys_ftrim) as f:
                ftrim_value = f.read().split()
        except IOError:
            pass
        return ftrim_value


    def fill_results(self):
        for ploop in self.get_ploops():
            self.ploop_info(ploop)
        self.result["ploop_info"] = ploop_dict
        self.result["ftrim_value"] = self.ioctl_ftrim()
        self.result["device_mapper_info"] = self.dm_ploops()


def main():
    o = ploop()
    o.run()


if __name__ == "__main__":
    main()
