#!/usr/bin/env python
#
# Copyright (c) 2016-2018, Virtuozzo International GmbH
#
# This file is part of disp-helper. It's free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
# Our contact details: Virtuozzo International GmbH, Vordergasse 59, 8200
# Schaffhausen, Switzerland.
#

import os
try:
    import ConfigParser
except:
    import configparser as ConfigParser
from infra_cep_helper import CEPCollecting


class Repos(CEPCollecting):
    def fill_results(self):
        cp = ConfigParser.ConfigParser()
        cp.read([os.path.join("/etc/yum.repos.d", file)
                 for file in os.listdir("/etc/yum.repos.d/")])
        for s in cp.sections():
            v = dict()
            for (key, value) in cp.items(s):
                v[key] = value
            self.result[s] = v


def main():
    o = Repos()
    o.run()


if __name__ == "__main__":
    main()
